From 8af4914f6b2bdf7df3a5b75cfd1b5cfaf2502f6b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:32:01 +0000
Subject: [PATCH 1287/2232] Merge pull request #423 from dtolnay/links


Implement CFG.exported_header_links
---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index deca600..8ee96cb 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -188,18 +188,13 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
         generate_bridge(prj, &mut build, path.as_ref())?;
     }
 
-    let mut crates = deps::direct_dependencies();
-    crates.insert(0, this_crate);
-
     eprintln!("\nCXX include path:");
-    for krate in crates {
-        for header_dir in &krate.header_dirs {
-            build.include(&header_dir.path);
-            if header_dir.exported {
-                eprintln!("  {}", header_dir.path.display());
-            } else {
-                eprintln!("  {} (private)", header_dir.path.display());
-            }
+    for header_dir in this_crate.header_dirs {
+        build.include(&header_dir.path);
+        if header_dir.exported {
+            eprintln!("  {}", header_dir.path.display());
+        } else {
+            eprintln!("  {} (private)", header_dir.path.display());
         }
     }
 
@@ -242,6 +237,25 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
         });
     }
 
+    for krate in deps::direct_dependencies() {
+        let links_attribute = match krate.links {
+            Some(links) => links,
+            None => continue,
+        };
+
+        let exported = CFG
+            .exported_header_links
+            .iter()
+            .any(|exported| links_attribute == *exported);
+
+        this_crate
+            .header_dirs
+            .extend(krate.header_dirs.into_iter().map(|dir| HeaderDir {
+                exported,
+                path: dir.path,
+            }));
+    }
+
     Ok(this_crate)
 }
 

